//========================================================================================
//
//	File:				FWMemSin.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWMEMSIN_H
#define FWMEMSIN_H

#include "SLMemSin.xh"

#ifndef FWRANSIN_H
#include "FWRanSin.h"
#endif

//========================================================================================
//	CLASS FW_PMemorySink
//
//		Inherited API for operator->()
//			long GetReadableBytes();
//			void Read(in void * destination, in long count);
//			long GetWritableBytes();
//			void Write(in void* source, in long count);
//
//			long GetLength();
//			void SetLength(in long length);
//			long GetPosition();
//			void SetPosition(in long position);
//
//========================================================================================

class FW_PMemorySink : public FW_PRandomAccessSink
{
public:
	FW_PMemorySink(Environment* ev, FW_OMemorySink* theMemorySink);
	FW_PMemorySink(Environment* ev, void* buffer, long capacity, long length);
		// Construct a memory sink given the buffer and the maximum capacity 
		// of the buffer.  The length is the number of bytes which have been 
		// written to the buffer.

	virtual ~FW_PMemorySink();

private:
	FW_PMemorySink(const FW_PMemorySink&);
	FW_PMemorySink& operator=(const FW_PMemorySink&);
};

#endif
