//========================================================================================
//
//	File:				FWRanSin.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWRANSIN_H
#define FWRANSIN_H

#include "SLRanSin.xh"

#ifndef FWSOMPTR_H
#include "FWSOMPtr.h"
#endif

//========================================================================================
//	CLASS FW_PRandomAccessSink
//	This class is a base class for the FW_PSink classes.  We avoid the replication 
//	of code for all the FW_TSOMPtr<FW_OSink> classes, which are almost all the same.
//
//		Inherited API for operator->()
//			long GetReadableBytes();
//			void Read(in void * destination, in long count);
//			long GetWritableBytes();
//			void Write(in void* source, in long count);
//
//		New API for operator->()
//			long GetLength();
//			void SetLength(in long length);
//			long GetPosition();
//			void SetPosition(in long position);
//
//========================================================================================

class FW_PRandomAccessSink : public FW_TSOMPtr<FW_ORandomAccessSink>
{
protected:
	FW_PRandomAccessSink();
	FW_PRandomAccessSink(Environment* ev, FW_ORandomAccessSink* theSink);

	virtual ~FW_PRandomAccessSink();

private:
	FW_PRandomAccessSink(const FW_PRandomAccessSink&);
	FW_PRandomAccessSink& operator=(const FW_PRandomAccessSink&);
};

//----------------------------------------------------------------------------------------
//	FW_PRandomAccessSink::FW_PRandomAccessSink
//----------------------------------------------------------------------------------------
inline FW_PRandomAccessSink::FW_PRandomAccessSink()
{
}

//----------------------------------------------------------------------------------------
//	FW_PRandomAccessSink::FW_PRandomAccessSink
//----------------------------------------------------------------------------------------
inline FW_PRandomAccessSink::FW_PRandomAccessSink(Environment* ev, FW_ORandomAccessSink* theSink) :
	FW_TSOMPtr<FW_ORandomAccessSink>(ev, theSink)
{
}

#endif
